import json

from clifinance.domain.expense.model import Expense


class JsonFileDriver:
    def read(self):
        try:
            with open("./app_data.json") as f:
                data = json.load(f)

            return self.__data_from_json(data)
        except FileNotFoundError:
            return list()
        except json.JSONDecodeError:
            return list()

    def write(self, data: list[Expense]):
        with open("./app_data.json", "w") as f:
            json.dump(self.__data_to_json(data), f)

    def __data_to_json(self, data: list[Expense]):
        return [x.to_json() for x in data]

    def __data_from_json(self, data: list[dict]):
        return [Expense.from_json(x) for x in data]
